//version 4.0.2
//section Finding your way around your data

//slide ------------------------------------------------------------------------
//title Searching

/*txt
{pstd}
The {cmd:lookfor} command is helpful for quickly finding the relevant variables
in your dataset 
txt*/

//ex
sysuse auto, clear
lookfor foreign
//endex

/*txt
{pstd}
{cmd:lookfor} only looks in the variable names and variable labels

{pstd}
Sometimes I know a term that should appear in the value labels

{pstd}
That is what {cmd:lookfor2} (available from SSC) is for
txt*/

//ex
lookfor2 domestic
//endex

/*txt
{pstd}
Once I have found a variable, I often want to see what variables are close

{pstd}
This is what {cmd:closedes} is for (it is part of the {cmd:lookfor2} package)
txt*/
//ex
closedesc headroom
//endex

/*txt 
{pstd}
sometimes I want to look for variables by other characteristics. For example, they have 
a certain value label, i.e. they are part of the same batery of questions.
txt*/

//ex
ds, has(type numeric)
ds, has(vallabel "*origin*")
//endex
//endslide ---------------------------------------------------------------------

//slide ------------------------------------------------------------------------
//title Getting an overview

/*txt
{pstd}
For getting a quick list of variables the {cmd:desc} command is useful

{pstd}
A similar command is {cmd:codebook} together with the {cmd:compact} option (the 
default is too verbose for my taste)
txt*/

//ex
codebook, compact
desc
//endex

/*txt
{pstd}
The {cmd:htmlcb} package (available from SSC) can be used getting a more detailed description of the data. 
txt*/

//ex
htmlcb, saving(cb.html) replace
//endex
//endslide ---------------------------------------------------------------------


//slide ------------------------------------------------------------------------
//title Describing variables

/*txt
An ugly, but extremely useful, graph for getting a good overview of a variable 
is {cmd:spikeplot}
txt*/

//ex
sysuse nlsw88
spikeplot hours
//endex
//graph Graph
/*txt
{pstd}
For categorical variables the {cmd:fre} command (from SSC by Ben Jann) is just 
absolutely necessary
txt*/

//ex
fre union
//endex

//endslide ---------------------------------------------------------------------

//slide ------------------------------------------------------------------------
//title Describing variables (special cases)

/*txt
{pstd}
Sometimes I have a number of variables that together represent a concept

{pstd}
For those cases I find {cmd:groups} (from SSC by Nick Cox) extremely helpful
txt*/

//ex
groups married never_married
tab married never_married
//endex

/*txt
{pstd}
With two variables we can get away with {cmd:tab}, but what if I also had 
variables living_together, and divorsed?

{pstd}
For panel data I sometimes want to see the entire history of a person if a 
certain condition is met. 

{pstd}
In this example we are looking at the retrospectively reported educational history
of a respondent

{pstd}
And we find some persons who after primary school immediately entered a university of applied sciences. 

{pstd}
We want to see what is going on
txt*/

//ex
use education.dta
lany ID_t sort start finish if start == 8 & sort == 2, by(ID_t) sepby(ID_t)
//endex
//file education.dta
//endslide ---------------------------------------------------------------------

